import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { Test, TestingModule } from '@nestjs/testing';
import { UserMessager } from '../../adapters/secondaries/user.messager';

const mockAmqpConnection = {
  publish: jest.fn().mockImplementation(),
};

describe('UserMessager', () => {
  let userMessager: UserMessager;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [],
      providers: [
        UserMessager,
        {
          provide: AmqpConnection,
          useValue: mockAmqpConnection,
        },
      ],
    }).compile();

    userMessager = module.get<UserMessager>(UserMessager);
  });

  it('should be defined', () => {
    expect(userMessager).toBeDefined();
  });

  it('should publish a message', async () => {
    jest.spyOn(mockAmqpConnection, 'publish');
    await userMessager.publish('user.create.info', 'my-test');
    expect(mockAmqpConnection.publish).toHaveBeenCalledTimes(1);
  });
});
